<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>README</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="how-to-use-docker-build-secrets">How to use Docker build secrets</h1>
<p>It’s common to need access to secret data to fully build an application from scratch. Commonly, builds pull sources or binaries from a private repository that requires authentication - private PyPI, npm, NuGet, etc. It’s also common to use a Dockerfile to perform application build and packaging when deploying apps as containers, to take advantage of an isolated environment. This presents a challenge, as we don’t want any secrets (files, environment variables, etc) to be captured in our image layers.</p>
<p>Docker 18.09 added some <a href="https://docs.docker.com/develop/develop-images/build_enhancements/#new-docker-build-secret-information">nice build enhancements</a>, including a feature called build secrets, that help us solve just this. The idea is simple: mount a volume at build time, use it in a <code>RUN</code> command, then don’t include it in our final image.</p>
<h2 id="an-example">An example</h2>
<p>This is an example of using build secrets with Python to pull from a private package repository. I’m using this <a href="https://github.com/Azure-Samples/azure-pipelines-python/tree/master/src/simple_package">simple_package</a> and I’m also making the assumption that if you’re reading this post, you have this problem and you already know how to build a Python package &amp; upload it to a repository somewhere.</p>
<h3 id="tldr">TL;DR:</h3>
<p>Run this, study the annotations as needed</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1"><span class="co"># Pass the path to your pip.conf (secret) and build an image</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="va">DOCKER_BUILDKIT=</span>1 <span class="ex">docker</span> build --secret id=pipconfig,src=/path/to/some/pip.conf -t myapp --progress=plain . </a>
<a class="sourceLine" id="cb1-3" title="3"><span class="ex">docker</span> run --rm -it -p 5000:5000 myapp</a></code></pre></div>
<h3 id="color-commentary">Color commentary</h3>
<h4 id="dockerfile">Dockerfile</h4>
<ul>
<li>It has to start with <code># syntax = docker/dockerfile:1.0-experimental</code> to light up the ability to use the new syntax</li>
<li>We reference a secret by <code>id</code>, in this case <code>pipconfig</code>. This should match the <code>id</code> you pass in during <code>docker build</code></li>
<li>We also set a destination to control where the mount lands. Otherwise it lands under <code>/run/secrets/{id}</code></li>
</ul>
<h4 id="docker-build"><code>docker build</code></h4>
<ul>
<li>BuildKit changes the output, so it can be hard to see what’s going on. <code>--progress=plain</code> gives a more familiar “Oh look, pip is installing packages” experience</li>
</ul>
</body>
</html>
